#include <SDL.h>
#include <cstdio>
#include <cmath>

void bucle(SDL_Renderer *renderer, int retardo);

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Renderer *renderer;

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow(NULL, SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    renderer = SDL_CreateRenderer(ventana, -1, 0);

    bucle(renderer, 0);

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}

void bucle(SDL_Renderer *renderer, int retardo) {
    Uint64 tick, tick0;
    SDL_FRect rect = {320.0, 240.0, 20.0, 20.0};
    SDL_Event test_event;
    SDL_FPoint destino = {320.0, 240.0};
    float velocidad = 200.0;
    float dirh;
    float dirv;
    bool salir = false;
    float dx, dx2, dy, dy2, d;

    tick0 = SDL_GetTicks64();
    do {
        tick = SDL_GetTicks64()-tick0;
        tick0 = SDL_GetTicks64();
        while(SDL_PollEvent(&test_event)) {
            switch(test_event.type) {
            case SDL_KEYDOWN:
                if(test_event.key.keysym.sym == SDLK_ESCAPE) { salir = true; }
                break;
            case SDL_MOUSEBUTTONUP:
                if(test_event.button.button == SDL_BUTTON_LEFT) {
                    destino.x = test_event.button.x;
                    destino.y = test_event.button.y;
                }
                break;
            case SDL_MOUSEBUTTONDOWN:
            case SDL_MOUSEMOTION:
            case SDL_MOUSEWHEEL:
                break;
            }
        }
        dx = destino.x - rect.x;
        dy = destino.y - rect.y;
        d = sqrt(dx*dx+dy*dy);
        if(d!=0) {
            dirh = dx/d;
            dirv = dy/d;
            dx2 = dirh*(velocidad*(tick)/1000.0);
            dy2 = dirv*(velocidad*(tick)/1000.0);
            if(abs(dx2) > abs(dx)) {
                dx2 = 0;
                rect.x = destino.x;
            }
            if(abs(dy2) > abs(dy)) {
                dy2 = 0;
                rect.y = destino.y;
            }
        }

        rect.x += dx2; //dirh*(velocidad*(tick)/1000.0);
        rect.y += dy2; //dirv*(velocidad*(tick)/1000.0);
        SDL_SetRenderDrawColor(renderer, 0,0,0,255);
        SDL_RenderClear(renderer);
        SDL_SetRenderDrawColor(renderer, 255,255,255,255);
        SDL_RenderDrawRectF(renderer, &rect);
        SDL_RenderPresent(renderer);
        SDL_Delay(retardo);
    } while(!salir);
}
